	.ORIG x3000
	LEA	R1, PROMPT	;R1 is the pointer to prompt string
	LEA	R7, #1		;the return address
	BRnzp	PRINT		;print the prompt string

	LEA	R3, NAME	;the start pointer of name string
	AND	R2, R2, #0	;clear R2 for counter
	ADD	R2, R2, #15	;maximum characters

INPUT	GETC			;getchar R0
	OUT
	ADD	R1, R0, #-10	;Enter = x0A
	BRz	READY		;user typed an Enter
	STR	R0, R3, #0	;store
	ADD	R3, R3, #1	;move pointer+1
	ADD	R2, R2, #-1	;update counter
	BRn	ERROR		;more than 15 chars
	BRnzp	INPUT		;input next char

READY	AND	R0, R0, #0
	STR	R0, R3, #0	;store x0000 into last position of string
	LEA	R0, POINTER	;the pointer to the first node

NODE	LDR	R0, R0, #0	;pointer to next node
	BRz	ERROR		;reach end of link list
	LEA	R3, NAME	;relocate R3 to the start of query string
	LDR	R1, R0, #1	;pointer to name string

NEXT	LDR	R2, R1, #0	;load current character of name string
	NOT	R2, R2
	ADD	R2, R2, #1	;R2 = -R2
	LDR	R4, R3, #0	;load R4 with query string
	ADD	R2, R2, R4	;compare query with name
	BRnp	NODE		;failed, move to next node
	ADD	R4, R4, #0	;whether current char is x0000
	BRz	FOUND		;found
	ADD	R1, R1, #1	;next char of name string
	ADD	R3, R3, #1	;next char of query string
	BRnzp	NEXT		;next char

FOUND	LDR	R1, R0, #2	;pointer to location string
	LEA	R7, #1		;the return address
	BRnzp	PRINT		;print the location string
	HALT

ERROR	LEA	R1, NOENTRY
	LEA	R7, #1		;the return address
	BRnzp	PRINT		;print the error string
	HALT

;this print routine can be done by PUTS
;this routine will kill R0 and R1
PRINT	LDR	R0, R1, #0	;R1 should store the pointer
	BRz	RETURN
	ST	R7, SAVER7
	OUT			;this system call will kill R7!!!
	LD	R7, SAVER7
	ADD	R1, R1, #1
	BRnzp	PRINT
RETURN	RET			;return to address set by caller

POINTER	.FILL	x3300
PROMPT	.STRINGZ "Type a last name and press Enter:"
NAME	.BLKW	16
NOENTRY	.STRINGZ "No Entry"
SAVER7	.BLKW	1
	.END